<?xml version="1.0" encoding="UTF-8"?>
<beans>
	<bean id="ColdboxFactory" class="coldbox.system.extras.ColdboxFactory" />
	<bean id="Coldbox" factory-bean="ColdBoxFactory" factory-method="getColdbox" singleton="true" />

	<!-- transfer integration -->
	<bean id="transferFactory" class="transfer.TransferFactory" singeleton="true">
		<constructor-arg name="datasourcePath">
			<value>${TransferSettings.datasourcePath}</value>
		</constructor-arg>
		<constructor-arg name="configPath">
		   <value>${TransferSettings.configPath}</value>
		</constructor-arg>
		<constructor-arg name="definitionPath">
		   <value>${TransferSettings.definitionPath}</value>
		</constructor-arg>
	</bean>
	
	<bean id="Transfer" factory-bean="TransferFactory" factory-method="getTransfer" singleton="true" />
	<bean id="Datasource" factory-bean="TransferFactory" factory-method="getDatasource" singleton="true" />

	<bean id="SecurityService" class="model.SecurityService">
		<constructor-arg name="oColdbox">
            <ref bean="Coldbox" />
      	</constructor-arg>
	</bean>	

	<bean id="AppUserGateway" class="model.appUser.AppUserGateway">
		<constructor-arg name="oTransfer">
            <ref bean="Transfer" />
      	</constructor-arg>
		<constructor-arg name="oDatasource">
            <ref bean="Datasource" />
      	</constructor-arg>
	</bean>

    <bean id="AppUserService" class="model.appUser.AppUserService">
		<constructor-arg name="oAppUserGateway">
            <ref bean="AppUserGateway" />
      	</constructor-arg>
		<constructor-arg name="oTransfer">
            <ref bean="Transfer" />
      	</constructor-arg>
	</bean>
	
</beans>