<!-----------------------------------------------------------------------
Author 	 :	Luis Majano
Date     :	September 25, 2005
Description :

	The galleon port.

----------------------------------------------------------------------->
<cfcomponent name="ehForums" extends="coldbox.system.eventhandler">

	<!--- ************************************************************* --->

	<cffunction name="onAppStart" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<!--- App Init Code --->
		<cfset structDelete(application, "userCache")>
		<!--- Get main settings --->
		<cfinvoke component="#getSetting("AppMapping")#/cfcs/galleon" method="getSettings" returnVariable="settings">
		<cfset application.settings = settings>
		
		<!--- Attachment Directory --->
		<cfset application.settings.attachmentdir = expandPath("./attachments")>
		<cfif not directoryExists(application.settings.attachmentdir)>
			<cfdirectory action="create" directory="#application.settings.attachmentdir#">
		</cfif>
		
		<!--- get user CFC --->
		<cfset application.user = createObject("component","#getSetting("AppMapping")#.cfcs.user").init(application.settings)>
		<!--- get utils CFC --->
		<cfset application.utils = createObject("component","#getSetting("AppMapping")#.cfcs.utils")>
		<!--- get conference CFC --->
		<cfset application.conference = createObject("component","#getSetting("AppMapping")#.cfcs.conference").init(application.settings)>
		<!--- get forum CFC --->
		<cfset application.forum = createObject("component","#getSetting("AppMapping")#.cfcs.forum").init(application.settings)>
		<!--- get thread CFC --->
		<cfset application.thread = createObject("component","#getSetting("AppMapping")#.cfcs.thread").init(application.settings)>
		<!--- get message CFC --->
		<cfset application.message = createObject("component","#getSetting("AppMapping")#.cfcs.message").init(application.settings)>
		<!--- get rank CFC --->
		<cfset application.rank = createObject("component","#getSetting("AppMapping")#.cfcs.rank").init(application.settings)>
		<cfset application.init = true>		
	</cffunction>
	
	<!--- ************************************************************* --->
	
	<cffunction name="onRequestStart" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var rc = Event.getCollection()>
		<!--- Logout Code --->
		<cfif Event.valueExists("logout")>
			<cfset runEvent("ehUsers.doLogout")>
		</cfif>

		<!--- handle security --->
		<cflogin></cflogin>

		<!--- Used by index, forums, and threads ---->
		<!--- however, if threads, default to lastpost --->
		<!--- however, don't do this in the admin ;) --->
		<!---<cfif not findNoCase("/admin", cgi.script_name)> --->
			<cfif findNoCase("dspThreads", cgi.script_name)>
				<cfset Event.paramValue("sort", "lastpost")>
				<cfset Event.paramValue("sortdir", "desc")>
			<cfelse>
				<cfset Event.paramValue("sort", "name")>
				<cfset Event.paramValue("sortdir", "asc")>
			</cfif>
		<!---</cfif> --->
		
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehProfile = "ehUsers.dspProfile" >
		<cfset rc.xehSearch = "ehForums.dspSearch">
		<cfset rc.xehLogin = "ehUsers.dspLogin">
		<cfset rc.xehRSS = "ehForums.dspRss">
	</cffunction>
	
	<!--- ************************************************************* --->

	<cffunction name="dspHome" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var rc = Event.getCollection()>
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehForums = "ehForums.dspForums">
		<cfset rc.xehMessages = "ehMessages.dspMessages">
		<!--- get my conferences --->
		<cfset rc.data = application.conference.getConferences()>
		<!--- if just one, auto go to a forums for it --->
		<cfif rc.data.recordCount is 1>
			<cfset setNextEvent("ehForums.dspForums","conferenceid=#rc.data.id#")>
		</cfif>
		<!--- sort --->
		<cfset rc.data = querySort(rc.data,Event.getValue("sort"),Event.getValue("sortdir"))>
		<!--- determine max pages --->
		<cfif rc.data.recordCount and rc.data.recordCount gt application.settings.perpage>
			<cfset Event.setValue("pages",ceiling(rc.data.recordCount / application.settings.perpage)) >
		<cfelse>
			<cfset Event.setValue("pages",1)>
		</cfif>
		<!--- Set Title and Templatename --->
		<cfset Event.setValue("title","#application.settings.title#")>
		<cfset Event.setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset Event.setView("vwIndex")>
	</cffunction>
	
	<!--- ************************************************************* --->
	
	<cffunction name="dspForums" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var rc = Event.getCollection()>
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehForums = "ehForums.dspForums">
		<cfset rc.xehThreads = "ehForums.dspThreads">
		<cfset rc.xehMessages = "ehMessages.dspMessages">
		<!--- Check for Conference --->
		<cfif not Event.valueExists("conferenceid") or not len(Event.getValue("conferenceid"))>
			<cfset setnextEvent("ehForums.dspHome")>
		</cfif>
		<!--- get parent conference --->
		<cftry>
			<cfset request.conference = application.conference.getConference(Event.getValue("conferenceid"))>
			<cfcatch>
				<cfset getPlugin("logger").logError("Error retreiving parent conference", cfcatch )>
				<cfset setnextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- get my forums --->
		<cfset rc.data = application.forum.getForums(conferenceid=Event.getValue("conferenceid")) >

		<!--- sort --->
		<cfset rc.data = querySort(rc.data,Event.getValue("sort"),Event.getValue("sortdir")) >

		<!--- determine max pages --->
		<cfif rc.data.recordCount and rc.data.recordCount gt application.settings.perpage>
			<cfset Event.setValue("pages", ceiling(rc.data.recordCount / application.settings.perpage) )>
		<cfelse>
			<cfset Event.setValue("pages", 1)>
		</cfif>

		<!--- Set Title and Templatename --->
		<cfset Event.setValue("title","#application.settings.title# : #request.conference.name#")>
		<cfset Event.setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset Event.setView("vwForums")>
	</cffunction>
	
	<!--- ************************************************************* --->
	
	<cffunction name="dspThreads" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var rc = Event.getCollection()>
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehForums = "ehForums.dspForums">
		<cfset rc.xehThreads = "ehForums.dspThreads">
		<cfset rc.xehMessages = "ehMessages.dspMessages">
		<cfset rc.xehNewPost = "ehMessages.dspNewPost">
		
		<!--- Chek for forum id --->	
		<cfif not Event.valueExists("forumid") or not len(Event.getValue("forumid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parents --->
		<cftry>
			<cfset request.forum = application.forum.getForum(Event.getValue("forumid"))>
			<cfset request.conference = application.conference.getConference(request.forum.conferenceidfk)>
			<cfcatch>
				<cfset getPlugin("logger").logError("Error getting forums and conferences information", cfcatch)>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>

		<!--- get my threads --->
		<cfset rc.data = application.thread.getThreads(forumid=Event.getValue("forumid"))>

		<!--- sort --->
		<cfset rc.data = querySort(rc.data,Event.getValue("sort"),Event.getValue("sortdir"))>

		<!--- determine max pages --->
		<cfif rc.data.recordCount and rc.data.recordCount gt application.settings.perpage>
			<cfset Event.setValue("pages",ceiling(rc.data.recordCount / application.settings.perpage))>
		<cfelse>
			<cfset Event.setValue("pages",1)>
		</cfif>
		<!--- Set Title and Templatename --->
		<cfset Event.setValue("title","#application.settings.title# : #request.conference.name# : #request.forum.name#")>
		<cfset Event.setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset Event.setView("vwThreads")>
	</cffunction>

	<!--- ************************************************************* --->
	
	<cffunction name="dspSearch" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var rc = Event.getCollection()>
		<!--- EXIT HANDLERS: --->
		<cfset rc.xehDoSearch = "ehForums.doSearch">
		<cfset rc.xehForums = "ehForums.dspForums">
		<cfset rc.xehThreads = "ehForums.dspThreads">
		<cfset rc.xehMessages = "ehMessages.dspMessages">
		
		<!--- Param values --->
		<cfset Event.paramValue("searchterms","")>
		<cfset Event.paramValue("searchtype","phrase")>
		<cfset rc.searchterms = trim(htmlEditFormat(application.utils.searchSafe(rc.searchterms)))>
		
		<!--- Set Title and Templatename --->
		<cfset Event.setValue("title","#application.settings.title# : Search")>
		<cfset Event.setValue("templatename","main")>
		<!--- Set the View To Display, after Logic --->
		<cfset Event.setView("vwSearch")>
	</cffunction>
	
	<!--- ************************************************************* --->
	
	<cffunction name="doSearch" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<!--- Handle attempted search --->
		<cfif not listFindNoCase("phrase,any,all", Event.getValue("searchtype",""))>
			<cfset Event.setValue("searchtype","phrase")>
		</cfif>
		<!---
			search multiple items:
				conferences (name/desc)
				forums (name/desc)
				threads (name)
				messages (title/body)
		--->
		<cfset Event.setValue("conferences", application.conference.search(Event.getValue("searchterms"), Event.getValue("searchtype")))>
		<cfset Event.setValue("forums", application.forum.search(Event.getValue("searchterms"), Event.getValue("searchtype")))>
		<cfset Event.setValue("threads", application.thread.search(Event.getValue("searchterms"), Event.getValue("searchtype")))>
		<cfset Event.setValue("messages", application.message.search(Event.getValue("searchterms"), Event.getValue("searchtype")))>
		
		<cfset application.utils.logSearch(Event.getValue("searchterms"), application.settings.dsn, application.settings.tableprefix)>
		<cfset Event.setValue("totalResults",Event.getValue("conferences").recordCount + Event.getValue("forums").recordCount + Event.getValue("threads").recordCount + Event.getValue("messages").recordCount)>
		
		<!--- Display Results --->
		<cfset dspSearch(Event)>
		<cfreturn>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspRss" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var rssdata = "">
		
		<cfif not Event.valueExists("conferenceid") or not len(Event.getValue("conferenceid"))>
			<cfset setNextEvent("ehForums.dspHome")>
		</cfif>

		<!--- get parent conference --->
		<cftry>
			<cfset request.conference = application.conference.getConference(Event.getValue("conferenceid"))>
			<cfcatch>
				<cfset setNextEvent("ehForums.dspHome")>
			</cfcatch>
		</cftry>
		
		<cfset rssdata = application.conference.getLatestPosts(conferenceid=Event.getValue("conferenceid"))>
		<!--- get my latest posts --->
		<cfset Event.setValue("rssdata",rssdata)>

		<!--- Set the View To Display, after Logic --->
		<cfset Event.setView("vwRss")>
	</cffunction>
	
	<!--- ************************************************************* --->
	
	</cfcomponent>