<!-----------------------------------------------------------------------
Author 	 :	Your Name
Date     :	September 25, 2005
Description :

	coldboxSamples.system.eventhandler

----------------------------------------------------------------------->
<cfcomponent name="ehGeneral" extends="coldbox.system.eventhandler">

	<!--- ************************************************************* --->
	<cffunction name="onRequestStart" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<!---
		Security Check
		You need to check for the doLogin method, beacuse, if not, the doLogin method
		will never get a chance to be called.
		So check if the session.loggedin flag exists or not true, and if we
		are not logging in.
		--->
		<cfscript>
			var rc = Event.getCollection();

			//Set xeh's
			rc.xehLogout = "ehGeneral.doLogout";
			rc.xehHome = "ehGeneral.dspHome";
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspLogin" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
			var rc = Event.getCollection();
			//Set xeh's
			rc.xehLogin = "ehGeneral.doLogin";
			//Set the page's title
			Event.setValue("title", "ColdBox - Sample Login App: Login page");
			//Set the view to display
			Event.setView("vwLogin");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doLogin" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
			//Do Login Procedure.
			var objDataStore = "";
			var rc = Event.getCollection();
			var ValidationStruct = "";
			//Error checks, does the form variables username & password exist
			//in the request collection? if they do, are they blank?
			if( not Event.valueExists("username") or not Event.valueExists("password") ){
				//Set a message to display
				getPlugin("messagebox").setMessage("error","No username or password defined.");
				getPlugin("logger").logEntry("error","Login without variables set detected.");
				//Redirect to next event, you can also add extra parameters to the URL
				setNextEvent("ehGeneral.dspLogin","username=#Event.getValue("username","")#");
			}
			else{
				//Init DataStorage
				objDataStore = CreateObject("component","#getSetting("AppMapping")#.model.datastore").init();
				ValidationStruct = objDataStore.validateUser(rc.username, rc.password);
				if ( ValidationStruct.validated ){
					//Login Correct.
					//set my session vars
					getPlugin("sessionstorage").setVar("loggedin",true);
					getPlugin("sessionstorage").setVar("name",ValidationStruct.qUser.name);
					//Log the entry
					getPlugin("logger").logEntry("information","The user #validationStruct.qUser.name# has now logged in.");
					//relocate to home page.
					setNextEvent("ehGeneral.dspHome");
				}
				else{
					//Set a message to display
					getPlugin("messagebox").setMessage("error","Invalid Logon Information. Please try again");
					getPlugin("logger").logEntry("warning","Invalid logon information detected. IP used: #cgi.remote_addr#");
					//Redirect to next event, you can also add extra parameters to the URL
					setNextEvent("ehGeneral.dspLogin","username=#Event.getValue("username")#");
				}	
			}
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="dspHome" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
			//Set the page's title
			Event.setValue("title", "Sample Login App: Welcome Back");
			//Set the view to display
			Event.setView("vwHome");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doLogout" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
			
			//Delete login INformation
			getPlugin("sessionstorage").clearAll();
			
			//Set the next event to display
			setNextEvent("ehGeneral.dspLogin");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->
</cfcomponent>